//ELEC3004_2014_Lab1c_Echo
//Ian Clough 18 March 2014
//School of ITEE, UQ
//This program reads an analog input, stores it to memory, then replays it later, mixed with the sample at that time.
void setup(){
  // The following lines setup power for the ADC and DAC Filter boards
  pinMode(A0,OUTPUT);//Vcc
  pinMode(A1,OUTPUT);//GND
  pinMode(A8,OUTPUT);//Vcc
  pinMode(A9,OUTPUT);//GND
  digitalWrite(A0,HIGH);  //power to ADCFilter 
  digitalWrite(A1,LOW);  //GND
  digitalWrite(A8,HIGH); //power to DACFilter
  digitalWrite(A9,LOW); //GND  
  
  analogReadResolution(12);//12 bits will fit neatly into a 16-bit variable
  analogWriteResolution(12);
  #define echolengthmax 45000 //45000samples is the max available space
  #define echolength 44900
}

void loop(){
 
  unsigned short echo[echolength]; 
  unsigned short echoctr=0,quack=0,mix=0;
  unsigned short D=39000; // Change the value of echo Delay to change the echo time
  
   for(unsigned short i=0;i<echolength;i++)
  {echo[i]=2048;} // pre-zero array to remove noise
  while(1)
  {
    unsigned short X0 = analogRead(A5); // Raw Input

	echo[echoctr]=X0; //store current sample
	if((echoctr-D)<0) 
	{quack=(echolength-1)+(echoctr-D);} // correct for negative array indices which are disallowed in C
	else
	{ quack=echoctr-D;}
	
	mix= (echo[echoctr]*0.5) + (echo[quack]*0.5); //these two elements can have different ratios to change the effect of echo
	echoctr++;
	if (echoctr>=echolength)
	{echoctr=0;}//reset counter at end of memory


	analogWrite(DAC1,mix);
	delayMicroseconds(20); // use this to change sample rate as well as echo time
	}//end while
}

